/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2003 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2003 Matthew Kendora and
                            Brad Jorsch (anomie@users.sourceforge.net)
 

                      
  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and
                            Nach (n-a-c-h@users.sourceforge.net)
                                          
  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2003 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman (jweidman@slip.net),
                            neviksti (neviksti@hotmail.com), and
                            Kris Bleakley (stinkfish@bigpond.com)
 
  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2003 zsKnight, pagefault (pagefault@zsnes.com)
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar and Gary Henderson.



 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

/*******************************************************************************
  Snes9x custom (Snes9x for Mac OS) by zones
  
  This build was started from John Stiles' port.
*******************************************************************************/

#include "port.h"

#include "os9-prefix.h"
#include "os9-2xsai.h"
#include "os9-blit.h"

int						gSrcP = 1024;

static unsigned char	XDelta[1024 * 240];

void BlitUpdateEntireDelta(void)
{
	UInt16	x, y, *d = (UInt16 *) XDelta;
	
	for (y = 0; y < 240; y++)
		for (x = 0; x < 512; x++)
			*d++ = 0x80008000;
}

void BlitClearExtendArea(register unsigned char *srcPtr, register Rect *srcRect)
{
	unsigned char	*clear;
	UInt16			height = srcRect->bottom - srcRect->top; // 224 or 239. width = 256.

	#define	BYTES_PER_PIXEL	2
	
	clear = srcPtr - (512 * 2 + 2) * BYTES_PER_PIXEL;
	memset(clear, 0, (2 + 256 + 2) * BYTES_PER_PIXEL);
	clear = srcPtr - (512 * 1 + 2) * BYTES_PER_PIXEL;
	memset(clear, 0, (2 + 256 + 2) * BYTES_PER_PIXEL);
	
	clear = srcPtr;
	for (UInt16 y = 0; y < height; y++)
	{
		*(UInt32 *) (clear -   2 * BYTES_PER_PIXEL) = 0;
		*(UInt32 *) (clear + 256 * BYTES_PER_PIXEL) = 0;
		clear += 512 * BYTES_PER_PIXEL;
	}
	
	clear = srcPtr + (512 * height       - 2) * BYTES_PER_PIXEL;
	memset(clear, 0, (2 + 256 + 2) * BYTES_PER_PIXEL);
	clear = srcPtr + (512 * (height + 1) - 2) * BYTES_PER_PIXEL;
	memset(clear, 0, (2 + 256 + 2) * BYTES_PER_PIXEL);
}

void BlitPixHiRes16(register unsigned char *srcPtr, register unsigned char *dstPtr, register long dstRowBytes, register Rect *srcRect, register Rect *dstRect)
{
	Byte	*finish, *dstPtr2;
	long	lineSize = (srcRect->right  - srcRect->left) << 1;
	long	height   =  srcRect->bottom - srcRect->top;
	
	srcPtr  += (2 * srcRect->left) + (gSrcP       * srcRect->top);
	dstPtr  += (2 * dstRect->left) + (dstRowBytes * dstRect->top);
	dstPtr2  = dstPtr + dstRowBytes;
	
	dstRowBytes <<= 1;
	
	do
	{
		double	*dP  = (double *) (dstPtr ),
				*dP2 = (double *) (dstPtr2),
				*bP  = (double *) (srcPtr );

		finish = (Byte *) bP + lineSize;
		
		do
		{
			*dP++ = *dP2++ = *bP++;
			*dP++ = *dP2++ = *bP++;
		}
		while ((Byte *) bP < finish);
		
		srcPtr  += gSrcP;
		dstPtr  += dstRowBytes;
		dstPtr2 += dstRowBytes;
	}
	while (--height);
}

void BlitPixHiResTV16(register unsigned char *srcPtr, register unsigned char *dstPtr, register long dstRowBytes, register Rect *srcRect, register Rect *dstRect)
{
	Byte	*finish, *dstPtr2;
	long	lineSize  = (srcRect->right  - srcRect->left) << 1;
	long	height    =  srcRect->bottom - srcRect->top;
	long	colorMask = 0x3DEF3DEF;
	
	srcPtr  += (2 * srcRect->left) + (gSrcP       * srcRect->top);
	dstPtr  += (2 * dstRect->left) + (dstRowBytes * dstRect->top);
	dstPtr2  = dstPtr + dstRowBytes;
	
	dstRowBytes <<= 1;
	
	do
	{
		unsigned long	*dP  = (unsigned long *) (dstPtr ),
						*dP2 = (unsigned long *) (dstPtr2),
						*bP  = (unsigned long *) (srcPtr ),
						value1, value2, total1, total2;

		finish = (Byte * ) bP + lineSize;
		
		do
		{
			value1 = *dP++ = *bP++;
			value2 = *dP++ = *bP++;
			
			total1  = (value1 = (value1 >> 1) & colorMask);
			total2  = (value2 = (value2 >> 1) & colorMask);
			total1 += (value1 = (value1 >> 1) & colorMask);
			*dP2++  = total1;
			total2 += (value2 = (value2 >> 1) & colorMask);
			*dP2++  = total2;			
		}
		while ((Byte *) bP < finish);
		
		srcPtr  += gSrcP;
		dstPtr  += dstRowBytes;
		dstPtr2 += dstRowBytes;
	}
	while (--height);
}

void BlitPixSmall16(register unsigned char *srcPtr, register unsigned char *dstPtr, register long dstRowBytes, register Rect *srcRect, register Rect *dstRect)
{
	Byte	*finish;
	long	lineSize = (srcRect->right  - srcRect->left) << 1;
	long	height   =  srcRect->bottom - srcRect->top;
	
	srcPtr += (2 * srcRect->left) + (gSrcP       * srcRect->top);
	dstPtr += (2 * dstRect->left) + (dstRowBytes * dstRect->top);
	
	do
	{
		double	*dP = (double *) (dstPtr),
				*bP = (double *) (srcPtr);

		finish = (Byte *) bP + lineSize;
		
		do
		{
			*dP++ = *bP++;
			*dP++ = *bP++;
		}
		while ((Byte *) bP < finish);
		
		srcPtr += gSrcP;
		dstPtr += dstRowBytes;
	}
	while (--height);
}

void BlitPixEagle16(register unsigned char *srcPtr, register unsigned char *dstPtr, register long dstRowBytes, register Rect *srcRect, register Rect *dstRect)
{
	srcPtr += (2 * srcRect->left) + (gSrcP       * srcRect->top);
	dstPtr += (2 * dstRect->left) + (dstRowBytes * dstRect->top);

	SuperEagle(srcPtr, gSrcP, XDelta, dstPtr, dstRowBytes, srcRect->right - srcRect->left, srcRect->bottom - srcRect->top);
}

void BlitPix2xSaI16(register unsigned char *srcPtr, register unsigned char *dstPtr, register long dstRowBytes, register Rect *srcRect, register Rect *dstRect)
{
	srcPtr += (2 * srcRect->left) + (gSrcP       * srcRect->top);
	dstPtr += (2 * dstRect->left) + (dstRowBytes * dstRect->top);

	_2xSaI(srcPtr, gSrcP, XDelta, dstPtr, dstRowBytes, srcRect->right - srcRect->left, srcRect->bottom - srcRect->top);
}

void BlitPixFiltered16(register unsigned char *srcPtr, register unsigned char *dstPtr, register long dstRowBytes, register Rect *srcRect, register Rect *dstRect)
{
	UInt32	lastLinePix[1024];
	UInt8	lastLineChg[1024];	
	Byte	*prevLine, *deltaPtr, *finish;
	long	lineSize     = (srcRect->right  - srcRect->left) << 1;
	long	height       =  srcRect->bottom - srcRect->top;
	long	dstLineSize  = dstRowBytes << 1;
	
	srcPtr  +=          (2 * srcRect->left) + (gSrcP       * srcRect->top);
	deltaPtr = XDelta + (2 * srcRect->left) + (gSrcP       * srcRect->top);
	prevLine = dstPtr + (2 * dstRect->left) + (dstRowBytes * dstRect->top);
	dstPtr   = prevLine + dstRowBytes;
	
	for (int index = 0; index < gSrcP; index++)
	{
		lastLinePix[index] = 0;
		lastLineChg[index] = 0;
	}

	do
	{
		unsigned char	*lC = (unsigned char *) lastLineChg;
		unsigned long	*bP = (unsigned long *) srcPtr,
						*xP = (unsigned long *) deltaPtr,
						*dP = (unsigned long *) dstPtr,
						*pL = (unsigned long *) prevLine,
						*lL = (unsigned long *) lastLinePix,
						colorMask    = 0x3DEF3DEF,
						lowPixelMask = 0x04210421,
						currentPixel, nextPixel, currentDelta, nextDelta, lastPix, lastChg, thisChg, currentPixA, currentPixB;
		UInt16			savePixel;
							   
		finish = srcPtr + lineSize + 4;
		 
		savePixel = *(UInt16 *) (srcPtr + lineSize);
		*(UInt16 *) (srcPtr + lineSize) = *(UInt16 *) (srcPtr + lineSize - 2);
		*(unsigned long *) (XDelta + lineSize) = *(unsigned long *) (srcPtr + lineSize);
		
		nextPixel = *bP++;
		nextDelta = *xP++;
		
		do
		{
			currentPixel = nextPixel;
			currentDelta = nextDelta;
			nextPixel    = *bP++;
			nextDelta    = *xP++;
			lastChg      = *lC;
			thisChg      = (nextPixel - nextDelta) | (currentPixel - currentDelta);
			
			unsigned long	colorA = (currentPixel >> 16) & 0xFFFF;
			unsigned long	colorB = (currentPixel      ) & 0xFFFF;
			unsigned long	colorC = (nextPixel    >> 16) & 0xFFFF;

			currentPixA = (colorA << 16) | (((colorA >> 1) & colorMask) + ((colorB >> 1) & colorMask) + (colorA & colorB & lowPixelMask));
			currentPixB = (colorB << 16) | (((colorC >> 1) & colorMask) + ((colorB >> 1) & colorMask) + (colorC & colorB & lowPixelMask));

			if (thisChg | lastChg)
			{
				xP[-2]  = currentPixel;
				
				lastPix = lL[0];
				dP[0]   = currentPixA;
				lL[0]   = currentPixA;
				pL[0]   = ((currentPixA >> 1) & colorMask) + ((lastPix >> 1) & colorMask) + (currentPixA & lastPix & lowPixelMask);
				
				lastPix = lL[1];
				dP[1]   = currentPixB;
				lL[1]   = currentPixB;
				pL[1]   = ((currentPixB >> 1) & colorMask) + ((lastPix >> 1) & colorMask) + (currentPixB & lastPix & lowPixelMask);
				
				*lC++   = (thisChg != 0);
			}
			else
			{								
				lL[0]   = currentPixA;
				lL[1]   = currentPixB;
				*lC++   = 0;
			}
			
			lL += 2;
			dP += 2;
			pL += 2;
		}
		while ((Byte *) bP < finish);

		*(UInt16 *) (srcPtr + lineSize) = savePixel;
				
		deltaPtr += gSrcP;
		srcPtr   += gSrcP;
		dstPtr   += dstLineSize;
		prevLine += dstLineSize;
	}
	while (--height);
}

void BlitPixScaled16(register unsigned char *srcPtr, register unsigned char *dstPtr, register long dstRowBytes, register Rect *srcRect, register Rect *dstRect)
{
	register unsigned char	*dstPtr2, *deltaPtr;
	
	long	lineSize = srcRect->right  - srcRect->left;
	long	height   = srcRect->bottom - srcRect->top;
	
	srcPtr  +=          (2 * srcRect->left) + (gSrcP       * srcRect->top);
	deltaPtr = XDelta + (2 * srcRect->left) + (gSrcP       * srcRect->top);
	dstPtr  +=          (2 * dstRect->left) + (dstRowBytes * dstRect->top);
	dstPtr2  = dstPtr + dstRowBytes;
	
	dstRowBytes <<= 1;
	
	do
	{
		unsigned long	*dP1 = (unsigned long *) dstPtr,
						*dP2 = (unsigned long *) dstPtr2,
						*bP  = (unsigned long *) srcPtr,
						*xP  = (unsigned long *) deltaPtr,
						currentPixel, lastPixel, currentPixA, currentPixB;

		for (long i = 0; i < (lineSize >> 1); i++)
		{
			currentPixel = *bP;
			lastPixel    = *xP;
			
			if (currentPixel != lastPixel)
			{			
				unsigned long	colorA = (currentPixel >> 16) & 0xFFFF;
				unsigned long	colorB = (currentPixel      ) & 0xFFFF;
				
				currentPixA = (colorA << 16) | colorA;
				currentPixB = (colorB << 16) | colorB;
	
				dP1[0] = currentPixA;
				dP1[1] = currentPixB;
				dP2[0] = currentPixA;
				dP2[1] = currentPixB;
				
				*xP = *bP;
			}
			
			bP++;
			xP++;
			dP1 += 2;
			dP2 += 2;
		}
		
		srcPtr   += gSrcP;
		deltaPtr += gSrcP;
		dstPtr   += dstRowBytes;
		dstPtr2  += dstRowBytes;
	}
	while (--height);
}

void BlitPixScaledTV16(register unsigned char *srcPtr, register unsigned char *dstPtr, register long dstRowBytes, register Rect *srcRect, register Rect *dstRect)
{
	register unsigned char	*dstPtr2, *deltaPtr;
	
	long			lineSize  = srcRect->right  - srcRect->left;
	long			height    = srcRect->bottom - srcRect->top;
	static long		colorMask = 0x3DEF3DEF, lowPixelMask = 0x0421;
	
	srcPtr  +=          (2 * srcRect->left) + (gSrcP       * srcRect->top);
	deltaPtr = XDelta + (2 * srcRect->left) + (gSrcP       * srcRect->top);
	dstPtr  +=          (2 * dstRect->left) + (dstRowBytes * dstRect->top);
	dstPtr2  = dstPtr + dstRowBytes;
	
	dstRowBytes <<= 1;

	do
	{
		unsigned long	*dP1 = (unsigned long *) dstPtr,
						*dP2 = (unsigned long *) dstPtr2,
						*bP  = (unsigned long *) srcPtr,
						*xP  = (unsigned long *) deltaPtr,
						currentPixel, nextPixel, currentDelta, nextDelta, colorA, colorB, product, darkened;
		
		for (long i = 0; i < (lineSize >> 1) - 1; i++)
		{
			currentPixel = *bP;
			currentDelta = *xP;
			nextPixel    = *(bP + 1);
			nextDelta    = *(xP + 1);

			if ((currentPixel != currentDelta) || (nextPixel != nextDelta))
			{
		    	*xP = *bP;
				
				colorA = (currentPixel >> 16) & 0xFFFF;
				colorB = (currentPixel      ) & 0xFFFF;
				
		    	*dP1       = product = (colorA << 16) | (((colorA >> 1) & colorMask) + ((colorB >> 1) & colorMask) + (colorA & colorB & lowPixelMask));
				
			    darkened  = (product = ((product >> 1) & colorMask));
			    darkened += (product = ((product >> 1) & colorMask));
			    darkened +=             (product >> 1) & colorMask;
				
		    	*dP2       = darkened;

				colorA = (nextPixel    >> 16) & 0xFFFF;
		    	
				*(dP1 + 1) = product = (colorB << 16) | (((colorA >> 1) & colorMask) + ((colorB >> 1) & colorMask) + (colorA & colorB & lowPixelMask));

			    darkened  = (product = ((product >> 1) & colorMask));
			    darkened += (product = ((product >> 1) & colorMask));
			    darkened +=             (product >> 1) & colorMask;
		    	
				*(dP2 + 1) = darkened;
			}
			
			bP++;
			xP++;
			dP1 += 2;
			dP2 += 2;
	    }

		// Last 2 Pixels
		
		currentPixel = *bP;
		currentDelta = *xP;

		if (currentPixel != currentDelta)
		{
			*xP = *bP;
			
			colorA = (currentPixel >> 16) & 0xFFFF;
			colorB = (currentPixel      ) & 0xFFFF;
			
			*dP1       = product = (colorA << 16) | (((colorA >> 1) & colorMask) + ((colorB >> 1) & colorMask) + (colorA & colorB & lowPixelMask));
			
			darkened  = (product = ((product >> 1) & colorMask));
			darkened += (product = ((product >> 1) & colorMask));
			darkened +=             (product >> 1) & colorMask;
			
			*dP2       = darkened;
			
			*(dP1 + 1) = product = (colorB << 16) | colorB;

			darkened  = (product = ((product >> 1) & colorMask));
			darkened += (product = ((product >> 1) & colorMask));
			darkened +=             (product >> 1) & colorMask;
			
			*(dP2 + 1) = darkened;
		}
			
		srcPtr   += gSrcP;
		deltaPtr += gSrcP;
		dstPtr   += dstRowBytes;
		dstPtr2  += dstRowBytes;
	}
	while (--height);
}
